routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes();


Route::middleware('auth')->group(function () {
    $this->any('/', function () {
        return view('index');
    })->name('index');


    Route::prefix('users')->name('users.')->group(function () {
        $this->any('/create', 'UserController@create')->name('create');
    });

    Route::prefix('subjects')->name('subjects.')->group(function () {
        $this->get('/', 'SubjectController@view')->name('index');
        $this->any('/create', 'SubjectController@create')->name('create');
        $this->any('/{subject}', 'SubjectController@update')->name('update');
        $this->any('/delete/{subject}', 'SubjectController@delete')->name('delete');
    });

    Route::prefix('faculties')->name('faculties.')->group(function () {
        $this->get('/', 'GroupController@view')->name('index');
        $this->get('/{id}', 'GroupController@directions')->name('direction');
        $this->get('/direction/{id}', 'GroupController@groups')->name('group');
        $this->get('/direction/group/{id}', 'GroupController@students')->name('student');
    });

    Route::prefix('plans')->name('plans.')->group(function () {
        $this->get('/', 'PlanController@semesters')->name('semesters');
        $this->get('/{semester}', 'PlanController@semester')->name('semester');
        $this->any('/{semester}/{group}', 'PlanController@group')->name('group');
    });
    Route::prefix('schedule')->name('schedule.')->group(function () {
        $this->get('/', 'LessonController@index')->name('index');
        $this->any('/{group}', 'LessonController@group')->name('group');
        $this->any('/prevWeek/{group}', 'LessonController@prevWeek')->name('prevWeek');
        $this->any('/add/{group}/{pair}/{day}', 'LessonController@add')->name('add');
        $this->any('/update/{lesson}/{day}', 'LessonController@update')->name('update');
    });

    Route::prefix('knowledge')->name('knowledge.')->group(function () {
        $this->get('/', 'KnowledgeController@index')->name('index');
        $this->post('/add', 'KnowledgeController@add')->name('add');
    });

});

resources/views/schedule/add.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <h5>{{ $group->name }} {{ $pair }} пара {{ $date->format('d.m.Y') }}. {{ $semester->number }} семестр.</h5>
        <form method="POST">
            @csrf
            <div class="form-group">
                <label for="subject">Выберите предмет</label>
                <select class="custom-select" id="subject" name="subject">
                    <option>Выберите...</option>
                    @foreach($subjects as $subject)
                        <option value="{{ $subject->id }}">{{ $subject->name }}</option>
                    @endforeach
                </select>
            </div>
            <div class="form-group">
                <label for="teacher">Выберите преподавателя</label>
                <select class="custom-select" id="teacher" name="teacher">
                    <option>Выберите...</option>
                    @foreach($teachers as $teacher)
                        <option value="{{ $teacher->id }}">{{ $teacher->second_name }} {{ $teacher->first_name }} {{ $teacher->middle_name }}</option>
                    @endforeach
                </select>
            </div>
            <div class="form-group">
                <label for="type">Выберите тип пары</label>
                <select class="custom-select" id="type" name="type">
                    <option>Выберите...</option>
                    <option value="lesson">Лекция</option>
                    <option value="practice">Практика</option>
                    <option value="laboratory">Лабораторная работа</option>
                </select>
            </div>
            <div class="form-group">
                <label for="period">Периодичность</label>
                <select class="custom-select" id="period" name="period">
                    <option>Выберите...</option>
                    <option value="1">Каждую неделю</option>
                    <option value="2">По четным неделям</option>
                    <option value="3">По нечетным неделям</option>
                    <option value="4">Определенные недели</option>
                </select>
            </div>
            <div class="form-group" id="periods" style="display: none;">
                <label for="weeks">Недели</label>
                <input type="text" class="form-control" name="weeks" id="weeks" placeholder="Введите недели через запятую">
            </div>
            <div class="form-group">
                <label for="room">Аудитория</label>
                <input type="text" class="form-control" name="room" id="room" placeholder="Введите номер аудитоории..."
                       value="{{ old('room') }}" required>
            </div>

            <button class="btn btn-sm btn-primary" type="submit">Добавить</button>
        </form>
    </div>

@endsection

@section('scripts')
    <script>
        $('document').ready(function () {
            $('#period').change(function () {
                if ($('#period').val() == 4) {
                    $('#periods').slideDown();
                }
                else {
                    $('#periods').slideUp();
                }
            })
        })
    </script>
@endsection

resources/views/schedule/group.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="d-flex flex-row justify-content-between">
            <h2>Группа {{ $group->name  }}</h2>
            <div>
                <span id="prev">Предыдушая неделя</span>
                <span id="next">Следующая неделя</span>
            </div>
        </div>
        <div class="row">
            <div class="col-1">
                <h5>Пара</h5>
                <div class="d-flex flex-column">
                    @foreach ($pairs as $pair)
                        <div class="pair-number">
                            <h5 class>{{ $pair['number'] }} пара</h5>
                            <p class>{{ $pair['pair_time'] }}</p>
                        </div>
                    @endforeach
                </div>
            </div>
            @foreach ($week as $day)
                <div class="col p-1">
                    <h5>{{ $day->format('d.m.Y') }}</h5>
                    <div class="d-flex flex-column">
                        @foreach ($pairs as $pair)
                            @php
                                $dates = \App\Date::where('date', $day->format('Y-m-d'))->get();
                                $lesson = null;
                                foreach ($dates as $date) {
                                    if ($date->lesson->pair_number == $pair['number'] && $date->lesson->group_id == $group->id) {
                                        $lesson = $date->lesson;
                                    }
                                }
                            @endphp
                            @if ($lesson)
                                @php
                                    $subject = $lesson->subject;
                                    $teacher = $lesson->teacher;
                                    $type = $lesson->type == 'practice' ? 'Практика' : $lesson->type == 'lesson' ? 'Лекция' : 'Лаб. работа';
                                @endphp
                                @if(auth()->user()->role_id == '3' || auth()->user()->role_id == '4')
                                    <div class="pair p-2">
                                        <div class="d-flex flex-column h-100">
                                            <span class="d-block text-danger">{{ $subject->name }}</span>
                                            <span class="d-block">{{ $teacher->second_name }}
                                                {{ mb_substr($teacher->first_name, 0, 1) . '.' }}
                                                {{ mb_substr($teacher->middle_name, 0, 1) . '.' }}</span>
                                            <div class="w-100 d-flex flex-row justify-content-between mt-auto">
                                                <span class="d-inline-block text-secondary">{{ $type }}</span>
                                                <span class="d-inline-block text-primary">{{ $lesson->room }}</span>
                                            </div>
                                        </div>
                                    </div>
                                @else
                                    <div class="pair upd p-2">
                                        <a href="{{ route('schedule.update', ['lesson' => $lesson, 'day' => $day]) }}"
                                           class="mx-auto">
                                            <div class="d-flex flex-column h-100">
                                                <span class="d-block text-danger">{{ $subject->name }}</span>
                                                <span class="d-block">{{ $teacher->second_name }}
                                                    {{ mb_substr($teacher->first_name, 0, 1) . '.' }}
                                                    {{ mb_substr($teacher->middle_name, 0, 1) . '.' }}</span>
                                                <div class="w-100 d-flex flex-row justify-content-between mt-auto">
                                                    <span class="d-inline-block text-secondary">{{ $type }}</span>
                                                    <span class="d-inline-block text-primary">{{ $lesson->room }}</span>
                                                </div>
                                            </div>
                                        </a>
                                    </div>
                                @endif
                            @else
                                @if(auth()->user()->role_id == '3' || auth()->user()->role_id == '4')
                                    <div class="pair p-2">
                                        <div class="add">
                                            <div class="text-muted">Нет пары</div>
                                        </div>
                                    </div>
                                @else
                                    <div class="pair p-2">
                                        <div class="add">
                                            <a href="{{ route('schedule.add', ['group' => $group, 'pair' => $pair['number'], 'day' => $day]) }}"
                                               class="btn btn-sm btn-outline-secondary mx-auto">Добавить</a>
                                        </div>
                                    </div>
                                @endif
                            @endif
                        @endforeach
                    </div>
                </div>
            @endforeach

        </div>
        @endsection

        @section('scripts')

            <script>
                $('document').ready(function () {
                    $('#prev').click(function () {
                        var week = @json($week);

                        $.ajax({
                            method: 'POST',
                            url: "{{ route('schedule.prevWeek', ['group'=>$group]) }}",
                            data: {week: week}
                        });
                    })
                })
            </script>

@endsection

resources/views/schedule/index.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <h2 class="mb-4">Выбор группы</h2>
        <div class="row">
            <div class="col-3">
                <h4>Факультеты</h4>
            </div>
            <div class="col-9">
                <h4>Направления</h4>
            </div>
        </div>
        <div class="row">
            <div class="col-3">
                <div class="nav flex-column nav-pills" id="v-pills-tab" role="tablist" aria-orientation="vertical">
                    @foreach($faculties as $key => $faculty)
                        <a class="nav-link {{ $key == 0 ? 'active' : '' }}" id="faculty_tab_{{$faculty->id}}"
                           data-toggle="tab" href="#faculty_content_{{$faculty->id}}" role="tab"
                           aria-controls="home" aria-selected="true">{{$faculty->name}}</a>
                    @endforeach
                </div>
            </div>
            <div class="col-9">
                <div class="tab-content" id="v-pills-tabContent">
                    @foreach($faculties as $key => $faculty)
                        <div class="tab-pane fade {{ $key == 0 ? 'active show' : '' }}" id="faculty_content_{{$faculty->id}}"
                             role="tabpanel">
                            <ul class="nav nav-tabs mb-3" id="directions" role="tablist">
                                @foreach(\App\Direction::where('faculty_id', $faculty->id)->get() as $key => $direction)
                                    <li class="nav-item">
                                        <a class="nav-link {{ $key == 0 ? 'active' : '' }}"
                                           id="direction_tab_{{$direction->id}}" data-toggle="tab"
                                           href="#direction_content_{{$direction->id}}" role="tab"
                                           aria-controls="home" aria-selected="true">{{$direction->name}}</a>
                                    </li>
                                @endforeach
                            </ul>
                            <div class="tab-content" id="directionsContent">
                                @foreach(\App\Direction::where('faculty_id', $faculty->id)->get() as $key => $direction)
                                    @if ($direction->faculty_id == $faculty->id)
                                        <div class="tab-pane fade {{ $key == 0 ? 'active show' : '' }}"
                                             id="direction_content_{{$direction->id}}" role="tabpanel">
                                            <h5>Группы</h5>
                                            @foreach($groups as $group)
                                                @if ($group->direction_id == $direction->id)
                                                    <a href="{{ route('schedule.group', ['group'=>$group]) }}">{{ $group->name }}</a>
                                                @endif
                                            @endforeach
                                        </div>
                                    @endif

                                @endforeach
                            </div>
                        </div>

                    @endforeach
                </div>
            </div>
        </div>
        <div class="tab-content" id="facultiesContent">

        </div>
    </div>



@endsection

resources/views/schedule/update.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <h5>{{ $group->name }} {{ $lesson->pair_number }} пара {{ $lesson->date }}</h5>
        <form method="POST">
            @csrf
            <div class="form-group">
                <label for="subject">Выберите предмет</label>
                <select class="custom-select" id="subject" name="subject">
                    <option>Выберите...</option>
                    @foreach($subjects as $subject)
                            <option {{ $lesson->subject_id == $subject->id ? 'selected' : '' }} value="{{ $subject->id }}">{{ $subject->name }}</option>
                    @endforeach
                </select>
            </div>
            <div class="form-group">
                <label for="teacher">Выберите преподавателя</label>
                <select class="custom-select" id="teacher" name="teacher">
                    <option>Выберите...</option>
                    @foreach($teachers as $teacher)
                        <option {{ $lesson->teacher_id == $teacher->id ? 'selected' : '' }} value="{{ $teacher->id }}">{{ $teacher->second_name }} {{ $teacher->first_name }} {{ $teacher->middle_name }}</option>
                    @endforeach
                </select>
            </div>
            <div class="form-group">
                <label for="type">Выберите тип пары</label>
                <select class="custom-select" id="type" name="type">
                    <option>Выберите...</option>
                    <option value="lesson" {{ $lesson->type == 'lesson' ? 'selected' : '' }}>Лекция</option>
                    <option value="practice" {{ $lesson->type == 'practice' ? 'selected' : '' }}>Практика</option>
                    <option value="laboratory" {{ $lesson->type == 'laboratory' ? 'selected' : '' }}>Лабораторная работа</option>
                </select>
            </div>
            <div class="form-group">
                <label for="period">Периодичность</label>
                <select class="custom-select" id="period" name="period">
                    <option>Выберите...</option>
                    <option value="1">Каждую неделю</option>
                    <option value="2">По четным неделям</option>
                    <option value="3">По нечетным неделям</option>
                    <option value="4">Определенные недели</option>
                </select>
            </div>
            <div class="form-group" id="periods" style="display: none;">
                <label for="weeks">Недели</label>
                <input type="text" class="form-control" name="weeks" id="weeks" placeholder="Введите недели через запятую">
            </div>
            <div class="form-group">
                <label for="room">Аудитория</label>
                <input type="text" class="form-control" name="room" id="room" placeholder="Введите номер аудитоории..."
                       value="{{ $lesson->room  }}" required>
            </div>

            <button class="btn btn-sm btn-primary" type="submit">Добавить</button>
        </form>
    </div>

@endsection

@section('scripts')
    <script>
        $('document').ready(function () {
            $('#period').change(function () {
                if ($('#period').val() == 4) {
                    $('#periods').slideDown();
                }
                else {
                    $('#periods').slideUp();
                }
            })
        })
    </script>
@endsection